/*********************************************************************
Copyright(C) 1994 by Vladimir Belkin
All Rights Reserved

E-mail: vladimir.belkin@usa.net

You are free to use this file for any purposes.

*********************************************************************/
#include <stdlib.h>
#include <stdio.h>

#include <dos.h>

#ifdef _WINDOWS
#include <windows.h>
#include <toolhelp.h>
#endif

#include "except.h"

Checked  *TheLastChecked=NULL;
TryToExecute  *TheLastTryToExecute=NULL;
int TheLastExceptionType=~0;
void *TheLastExceptionLvalue=NULL;

#ifndef _WINDOWS

  unsigned TheStackBottom=NULL;
  void SetTheStackBottom(void  *p) {
    TheStackBottom=(unsigned)p;
  }
  
#endif


#ifdef _WINDOWS
  inline unsigned getStackHigh() {
    TASKENTRY tke={sizeof(TASKENTRY)};
    TaskFindHandle(&tke,GetCurrentTask());
    return tke.wStackBottom;
  }
#endif

inline unsigned getSP() {
unsigned i;
  __asm mov i,sp;
  return i;
}

inline unsigned getSS() {
unsigned i;
  __asm mov ax,ss;
  __asm mov i,ax;
  return i;
}  

int StackLocated(void  *p) {
#ifndef _WINDOWS
   return ((unsigned)(p)>getSP())&&((unsigned)(p)<=TheStackBottom);
#else
   return ((unsigned)(p)>getSP())&&((unsigned)(p)<=getStackHigh());
#endif
}

void xThrow(void) {
  OnException(
    TheLastExceptionType,
    TheLastExceptionLvalue
  );
}

void Checked::DestroyChecked() {
  this->~Checked();
  if (TheLastChecked!=NULL) TheLastChecked->DestroyChecked();
}

inline unsigned FPSEG(void __far *p) {
  return FP_SEG(p);
}


Checked::~Checked() {
#if M_I86LM || M_I86CM || M_I86VM
  if (FPSEG(this)==getSS())
#endif
  if (StackLocated((void  *)this))
    if (TheLastChecked==this) TheLastChecked=prev;
    else
      for (Checked *p=TheLastChecked;p!=NULL;p=p->prev)
        if (p->prev==this) { p->prev=prev; break; }
}


Checked::Checked() {
//  if (TheLastTryToExecute!=NULL)
#if M_I86LM || M_I86CM || M_I86VM
  if (FPSEG(this)==getSS())
#endif
  if (StackLocated((void  *)this))
  {
    prev=TheLastChecked;
    if (TheLastChecked!=(Checked  *)this)
         TheLastChecked=(Checked  *)this;
  }
}

void Checked::resetChecked() {
  if (StackLocated((void  *)this)) TheLastChecked=(Checked  *)this;
}

void TryToExecute::OnError(int _type,void *ptr) {
  if (TheLastChecked!=NULL) {
    Checked  *p=TheLastChecked;
    TheLastChecked=TheLastChecked->prev;
    p->DestroyChecked();
  }
  type=_type;lvalue=ptr;
  TheLastChecked=chk;
  TheLastTryToExecute=tr;
  longjmp(buf,~0);
}



TryToExecute::TryToExecute():type(0) {
#if M_I86LM || M_I86CL || M_I86VM
    if (FPSEG(this)==getSS())
#endif
 {
  chk=TheLastChecked;TheLastChecked=NULL;
  tr=TheLastTryToExecute;TheLastTryToExecute=(TryToExecute  *)this;
 }
}

TryToExecute::~TryToExecute() {
  TheLastTryToExecute=tr;
  if (type) OnException(type,lvalue);
}

void OnException(int type,void *p) {
  TheLastExceptionType=type;
  TheLastExceptionLvalue=p;
  if (TheLastTryToExecute==NULL) {
     if (TheLastChecked!=NULL) {
       Checked  *p=TheLastChecked;
       TheLastChecked=TheLastChecked->prev;
       p->DestroyChecked();
     }
     terminate();
  }
  TheLastTryToExecute->OnError(type,p);
}

char exceptionBuffer[MAX_EXCEPTION_SIZE];

void checkExceptionSize(int sz,int tid) {
  if (sz>MAX_EXCEPTION_SIZE) xThrow(XX_invalid_size(tid));
}

static void OnTerminate() {
#ifdef _WINDOWS
  static char buf[81];
  wsprintf(buf,"FATAL: Unhandled exception index %d",TheLastExceptionType);
  FatalAppExit(0,buf);
#else
  fprintf(stderr,"FATAL: Unhandled exception index %d\n",TheLastExceptionType);
  exit(-1);
#endif  
}

static PFVV terminator=OnTerminate;

PFVV set_terminate(PFVV new_terminator) {
PFVV old_terminator=terminator;
  terminator=new_terminator;
  return old_terminator;
};

void terminate() {
  (*terminator)();
}

